# std::basic_istream< _CharT, _Traits > Class Template Reference

Controlling input. More...

Inheritance diagram for std::basic_istream< _CharT, _Traits >:

[legend]
Collaboration diagram for std::basic_istream< _CharT, _Traits >:

[legend]
List of all members.

## Public Types

typedef _CharT | char_type
typedef _Traits::int_type | int_type
typedef _Traits::pos_type | pos_type
typedef _Traits::off_type | off_type
typedef _Traits | traits_type

## Public Methods

| basic_istream (__streambuf_type *__sb)
| Base constructor.
virtual | ~basic_istream ()
| Base destructor.
streamsize | gcount () const
| Character counting.
__istream_type & | operator>> (__istream_type &(*__pf)(__istream_type &))
| Interface for manipulators.
__istream_type & | operator>> (__ios_type &(*__pf)(__ios_type &))
| Interface for manipulators.
__istream_type & | operator>> (ios_base &(*__pf)(ios_base &))
| Interface for manipulators.
Arithmetic Extractors

All the `operator>>` functions (aka formatted input functions) have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to false. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

__istream_type & | operator>> (bool &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (short &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned short &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (int &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned int &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (long long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (unsigned long long &__n)
| Basic arithmetic extractors.
__istream_type & | operator>> (float &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (long double &__f)
| Basic arithmetic extractors.
__istream_type & | operator>> (void *&__p)
| Basic arithmetic extractors.
__istream_type & | operator>> (__streambuf_type *__sb)
| Extracting into another streambuf.
Unformatted Input Functions

All the unformatted input functions have some common behavior. Each starts by constructing a temporary object of type std::basic_istream::sentry with the second argument (noskipws) set to true. This has several effects, concluding with the setting of a status flag; see the sentry documentation for more.

If the sentry status is good, the function tries to extract whatever data is appropriate for the type of the argument.

The number of characters extracted is stored for later retrieval by gcount().

If an exception is thrown during extraction, ios_base::badbit will be turned on in the stream's error state without causing an ios_base::failure to be thrown. The original exception will then be rethrown.

int_type | get ()
| Simple extraction.
__istream_type & | get (char_type &__c)
| Simple extraction.
__istream_type & | get (char_type *__s, streamsize __n, char_type __delim)
| Simple multiple-character extraction.
__istream_type & | get (char_type *__s, streamsize __n)
| Simple multiple-character extraction.
__istream_type & | get (__streambuf_type &__sb, char_type __delim)
| Extraction into another streambuf.
__istream_type & | get (__streambuf_type &__sb)
| Extraction into another streambuf.
__istream_type & | getline (char_type *__s, streamsize __n, char_type __delim)
| String extraction.
__istream_type & | getline (char_type *__s, streamsize __n)
| String extraction.
__istream_type & | ignore (streamsize __n=1, int_type __delim=traits_type::eof())
| Discarding characters.
int_type | peek ()
| Looking ahead in the stream.
__istream_type & | read (char_type *__s, streamsize __n)
| Extraction without delimiters.
streamsize | readsome (char_type *__s, streamsize __n)
| Extraction until the buffer is exhausted, but no more.
__istream_type & | putback (char_type __c)
| Unextracting a single character.
__istream_type & | unget ()
| Unextracting the previous character.
int | sync ()
| Synchronizing the stream buffer.
pos_type | tellg ()
| Getting the current read position.
__istream_type & | seekg (pos_type)
| Changing the current read position.
__istream_type & | seekg (off_type, ios_base::seekdir)
| Changing the current read position.

## Detailed Description

### template<typename _CharT, typename _Traits>
class std::basic_istream< _CharT, _Traits >

Controlling input.

This is the base class for all input streams. It provides text formatting of all builtin types, and communicates with any class derived from basic_streambuf to do the actual input.

Definition at line 58 of file istream.

## Member Typedef Documentation

template<typename _CharT, typename _Traits>
typedef _CharT std::basic_istream< _CharT, _Traits >::char_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_ios< _CharT, _Traits > .

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 62 of file istream.

Referenced by std::basic_istream< _CharT, _Traits >::get() , std::basic_istream< char >::get() , std::basic_istream< _CharT, _Traits >::getline() , and std::basic_istream< char >::getline() .

template<typename _CharT, typename _Traits>
typedef _Traits::int_type std::basic_istream< _CharT, _Traits >::int_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_ios< _CharT, _Traits > .

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 63 of file istream.

Referenced by std::basic_istream< _CharT, _Traits >::get() , std::basic_istream< _CharT, _Traits >::getline() , std::basic_istream< _CharT, _Traits >::ignore() , std::basic_istream< _CharT, _Traits >::peek() , std::basic_istream< _CharT, _Traits >::putback() , and std::basic_istream< _CharT, _Traits >::unget() .

template<typename _CharT, typename _Traits>
typedef _Traits::off_type std::basic_istream< _CharT, _Traits >::off_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_ios< _CharT, _Traits > .

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 65 of file istream.

Referenced by std::basic_istream< _CharT, _Traits >::seekg() .

template<typename _CharT, typename _Traits>
typedef _Traits::pos_type std::basic_istream< _CharT, _Traits >::pos_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_ios< _CharT, _Traits > .

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 64 of file istream.

Referenced by std::basic_istream< _CharT, _Traits >::seekg() , and std::basic_istream< _CharT, _Traits >::tellg() .

template<typename _CharT, typename _Traits>
typedef _Traits std::basic_istream< _CharT, _Traits >::traits_type

These are standard types. They permit a standardized way of referring to names of (or names dependant on) the template parameters, which are specific to the implementation.

Reimplemented from std::basic_ios< _CharT, _Traits > .

Reimplemented in std::basic_ifstream< _CharT, _Traits > , std::basic_fstream< _CharT, _Traits > , std::basic_istringstream< _CharT, _Traits, _Alloc > , and std::basic_stringstream< _CharT, _Traits, _Alloc > .

Definition at line 66 of file istream.

## Constructor & Destructor Documentation

template<typename _CharT, typename _Traits>
std::basic_istream< _CharT, _Traits >::basic_istream | ( | __streambuf_type * | __sb | ) | `[inline, explicit]`

| Base constructor. This ctor is almost never called by the user directly, rather from derived classes' initialization lists, which pass a pointer to their own stream buffer. Definition at line 96 of file istream.

template<typename _CharT, typename _Traits>
virtual std::basic_istream< _CharT, _Traits >::~basic_istream | ( |  | ) | `[inline, virtual]`

| Base destructor. This does very little apart from providing a virtual base dtor. Definition at line 108 of file istream.

## Member Function Documentation

template<typename _CharT, typename _Traits>
streamsize std::basic_istream< _CharT, _Traits >::gcount | ( |  | ) | const`[inline]`

Character counting.

Returns:
  The number of characters extracted by the previous unformatted input function dispatched for this stream.

Definition at line 235 of file istream.

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb | ) | `[inline]`

Extraction into another streambuf.

Parameters:

  sb | A streambuf in which to store data.

Returns:
  *this

Returns `get(sb,widen('')).`

Definition at line 352 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | __streambuf_type & | __sb,
|  | char_type | __delim
| ) |

Extraction into another streambuf.

Parameters:

  sb | A streambuf in which to store data.
  delim | A "stop" character.

Returns:
  *this

Characters are extracted and inserted into sb until one of the following happens:

- the input sequence reaches EOF
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted)
- the next character equals delim (in this case, the character is not extracted)
- an exception occurs (and in this case is caught)

If no characters are stored, failbit is set in the stream's error state.

Definition at line 621 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type , std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline]`

Simple multiple-character extraction.

Parameters:

  s | Pointer to an array.
  n | Maximum number of characters to store in s.

Returns:
  *this

Returns `get(s,n,widen('')).`

Definition at line 319 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim
| ) |

Simple multiple-character extraction.

Parameters:

  s | Pointer to an array.
  n | Maximum number of characters to store in s.
  delim | A "stop" character.

Returns:
  *this

Characters are extracted and stored into s until one of the following happens:

- `n-1` characters are stored
- the input sequence reaches EOF
- the next character equals delim, in which case the character is not extracted

If no characters are stored, failbit is set in the stream's error state.

In any case, a null character is stored into the next location in the array.

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 579 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type , std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::get | ( | char_type & | __c | ) |

Simple extraction.

Parameters:

  c | The character in which to store data.

Returns:
  *this

Tries to extract a character and store it in c. If none are available, sets failbit and returns traits::eof().

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 545 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::get | ( |  | ) |

Simple extraction.

Returns:
  A character, or eof().

Tries to extract a character. If none are available, sets failbit and returns traits::eof().

Definition at line 513 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

Referenced by std::basic_istream< char >::get() , and std::operator>>() .

template<typename _CharT, typename _Traits>
__istream_type& std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n
| ) | `[inline]`

String extraction.

Parameters:

  s | A character array in which to store the data.
  n | Maximum number of characters to extract.

Returns:
  *this

Returns `getline(s,n,widen('')).`

Definition at line 392 of file istream.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::getline | ( | char_type * | __s,
|  | streamsize | __n,
|  | char_type | __delim
| ) |

String extraction.

Parameters:

  s | A character array in which to store the data.
  n | Maximum number of characters to extract.
  delim | A "stop" character.

Returns:
  *this

Extracts and stores characters into s until one of the following happens. Note that these criteria are required to be tested in the order listed here, to allow an input line to exactly fill the s array without setting failbit.

1. the input sequence reaches end-of-file, in which case eofbit is set in the stream error state
2. the next character equals `delim,` in which case the character is extracted (and therefore counted in `gcount())` but not stored
3. `n-1` characters are stored, in which case failbit is set in the stream error state

If no characters are extracted, failbit is set. (An empty line of input should therefore not cause failbit to be set.)

In any case, a null character is stored in the next location in the array.

Definition at line 663 of file istream.tcc.

References std::basic_istream< _CharT, _Traits >::char_type , std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

Referenced by std::basic_istream< char >::getline() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::ignore | ( | streamsize | __n = 1,
|  | int_type | __delim = traits_type::eof()
| ) |

Discarding characters.

Parameters:

  n | Number of characters to discard.
  delim | A "stop" character.

Returns:
  *this

Extracts characters and throws them away until one of the following happens:

- if n `!=` `std::numeric_limits<int>::max(),` n characters are extracted
- the input sequence reaches end-of-file
- the next character equals delim (in this case, the character is extracted); note that this condition will never occur if delim equals `traits::eof().`

Definition at line 715 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::max() , std::min() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __streambuf_type * | __sb | ) |

Extracting into another streambuf.

Parameters:

  sb | A pointer to a streambuf

This function behaves like one of the basic arithmetic extractors, in that it also constructs a sentry onject and has the same error handling behavior.

If sb is NULL, the stream will set failbit in its error state.

Characters are extracted from this stream and inserted into the sb streambuf until one of the following occurs:

- the input stream reaches end-of-file,
- insertion into the output buffer fails (in this case, the character that would have been inserted is not extracted), or
- an exception occurs (and in this case is caught)

If the function inserts no characters, failbit is set.

Definition at line 482 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | void *& | __p | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 455 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long double & | __f | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 428 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | double & | __f | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 401 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | float & | __f | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 374 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long long & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 346 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long long & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 319 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned long & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 291 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | long & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 264 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned int & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 237 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | int & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 200 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | unsigned short & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 173 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | short & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 136 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | bool & | __n | ) |

Basic arithmetic extractors.

Parameters:

  A | variable of builtin type.

Returns:
  `*this` if successful

These functions use the stream's current locale (specifically, the `num_get` facet) to parse the input data.

Definition at line 109 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | ios_base &(* | __pf)(ios_base &) | ) |

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 100 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __ios_type &(* | __pf)(__ios_type &) | ) |

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 91 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::operator>> | ( | __istream_type &(* | __pf)(__istream_type &) | ) |

| Interface for manipulators. Manuipulators such as `std::ws` and `std::dec` use these functions in constructs like "std::cin >> std::ws". For more information, see the iomanip header. Definition at line 82 of file istream.tcc.

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::int_type std::basic_istream< _CharT, _Traits >::peek | ( |  | ) |

Looking ahead in the stream.

Returns:
  The next character, or eof().

If, after constructing the sentry object, `good()` is false, returns `traits::eof().` Otherwise reads but does not extract the next input character.

Definition at line 753 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::putback | ( | char_type | __c | ) |

Unextracting a single character.

Parameters:

  c | The character to push back into the input stream.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sputbackc(c).`

If `rdbuf()` is null or if `sputbackc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 842 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::read | ( | char_type * | __s,
|  | streamsize | __n
| ) |

Extraction without delimiters.

Parameters:

  s | A character array.
  n | Maximum number of characters to store.

Returns:
  *this

If the stream state is `good(),` extracts characters and stores them into s until one of the following happens:

- n characters are stored
- the input sequence reaches end-of-file, in which case the error state is set to `failbit|eofbit.`

Note:
  This function is not overloaded on signed char and unsigned char.

Definition at line 777 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
streamsize std::basic_istream< _CharT, _Traits >::readsome | ( | char_type * | __s,
|  | streamsize | __n
| ) |

Extraction until the buffer is exhausted, but no more.

Parameters:

  s | A character array.
  n | Maximum number of characters to store.

Returns:
  The number of characters extracted.

Extracts characters and stores them into s depending on the number of characters remaining in the streambuf's buffer, `rdbuf()->in_avail(),` called `A` here:

- if `A` `==` `-1,` sets eofbit and extracts no characters
- if `A` `==` `0,` extracts no characters
- if `A` `>` `0,` extracts `min(A,n)`

The goal is to empty the current buffer, and to not request any more from the external input sequence controlled by the streambuf.

Definition at line 806 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::min() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | off_type | ,
|  | ios_base::seekdir |
| ) |

Changing the current read position.

Parameters:

  off | A file offset object.
  dir | The direction in which to seek.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekoff(off,dir).` If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount().`

Definition at line 967 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail() , std::basic_istream< _CharT, _Traits >::off_type , std::basic_istream< _CharT, _Traits >::pos_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::seekg | ( | pos_type |  | ) |

Changing the current read position.

Parameters:

  pos | A file position object.

Returns:
  *this

If `fail()` is not true, calls `rdbuf()->pubseekpos(pos).` If that function fails, sets failbit.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount().`

Definition at line 948 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail() , std::basic_istream< _CharT, _Traits >::off_type , std::basic_istream< _CharT, _Traits >::pos_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
int std::basic_istream< _CharT, _Traits >::sync | ( |  | ) |

Synchronizing the stream buffer.

Returns:
  0 on success, -1 on failure

If `rdbuf()` is a null pointer, returns -1.

Otherwise, calls `rdbuf()->pubsync(),` and if that returns -1, sets badbit and returns -1.

Otherwise, returns 0.

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount().`

Definition at line 904 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits >::pos_type std::basic_istream< _CharT, _Traits >::tellg | ( |  | ) |

Getting the current read position.

Returns:
  A file position object.

If `fail()` is not false, returns `pos_type(-1)` to indicate failure. Otherwise returns `rdbuf()->pubseekoff(0,cur,in).`

Note:
  This function does not count the number of characters extracted, if any, and therefore does not affect the next call to `gcount().`

Definition at line 936 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::fail() , std::basic_istream< _CharT, _Traits >::pos_type , and std::basic_ios< _CharT, _Traits >::rdbuf() .

template<typename _CharT, typename _Traits>
basic_istream< _CharT, _Traits > & std::basic_istream< _CharT, _Traits >::unget | ( |  | ) |

Unextracting the previous character.

Returns:
  *this

If `rdbuf()` is not null, calls `rdbuf()->sungetc(c).`

If `rdbuf()` is null or if `sungetc()` fails, sets badbit in the error state.

Note:
  Since no characters are extracted, the next call to `gcount()` will return 0, as required by DR 60.

Definition at line 873 of file istream.tcc.

References std::basic_ios< _CharT, _Traits >::exceptions() , std::basic_istream< _CharT, _Traits >::int_type , std::basic_ios< _CharT, _Traits >::rdbuf() , and std::basic_ios< _CharT, _Traits >::setstate() .

The documentation for this class was generated from the following files:

- istream
- istream.tcc